﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using XLDLL_Financial_Demo;


namespace XLDLL_Financial_Demo
{
    public partial class frm_Demo1 : Form
    {
        private TextWriter _writer;

        public frm_Demo1()
        {
            InitializeComponent();

            // Instantiate the writer
            _writer = new TextBoxStreamWriter(txtConsole);

            // Redirect the out Console stream
            Console.SetOut(_writer);

            Test_financial.test_XLDLL_FINANCIAL_VERSION();

            Console.WriteLine("\r\n" + "-------------------------------------" + "\r\n");

        }

        private void Button1_Click(object sender, EventArgs e)
        {
            //-----------------------------------
            //*** XLeratorDLL / financial
            //-----------------------------------

            //!!! Note: This messagebox can be omitted...
            MessageBox.Show("Instructions: Un-comment desired function demonstration method... 'Test_financial.test_<<function_name>>' ... from frm_Demo1.cs:Button1_Click");


            ///***************************************/
            ///***                                 ***/
            ///***     PRICE & YIELD FUNCTIONS     ***/
            ///***                                 ***/
            ///***************************************/

            //Test_financial.test_PRICE();
            //Test_financial.test_YIELD();
            //Test_financial.test_RPI();
            //Test_financial.test_RPIFactors();

            //Test_financial.test_PRICEMAT();
            //Test_financial.test_YIELDMAT();
            //Test_financial.test_IAM();
            //Test_financial.test_IAMFACTORS();

            //Test_financial.test_PRICEDISC();
            //Test_financial.test_YIELDDISC();
            //Test_financial.test_DISC();
            //Test_financial.test_DIS();
            //Test_financial.test_DISFACTORS();

            //Test_financial.test_ODDFPRICE();
            //Test_financial.test_ODDFYIELD();
            //Test_financial.test_OFCFACTORS();
            //Test_financial.test_OFC();

            //Test_financial.test_ODDLPRICE();
            //Test_financial.test_ODDLYIELD();
            //Test_financial.test_OLCFACTORS();
            //Test_financial.test_OLC();

            //Test_financial.test_OFLPRICE();
            //Test_financial.test_OFLYIELD();
            //Test_financial.test_OFLFACTORS();
            //Test_financial.test_OFL();

            //Test_financial.test_PRICEACT();
            //Test_financial.test_YIELDACT();
            //Test_financial.test_PRICEACTTV();

            //Test_financial.test_PRICEFR();
            //Test_financial.test_YIELDFR();

            //Test_financial.test_DIRTYPRICE();
            //Test_financial.test_DIRTYYIELD();

            //Test_financial.test_TBILLEQ();
            //Test_financial.test_TBILLPRICE();
            //Test_financial.test_YIELD();

            //Test_financial.test_BONDCF();
            //Test_financial.test_STEPCF();

            ///***********************************/
            ///***                             ***/
            ///***     BOND DATE FUNCTIONS     ***/
            ///***                             ***/
            ///***********************************/

            //Test_financial.test_COUPDAYBS();
            //Test_financial.test_COUPDAYS();
            //Test_financial.test_COUPDAYSNC();
            //Test_financial.test_COUPNCD();
            //Test_financial.test_COUPNUM();
            //Test_financial.test_COUPPCD();


            ///**********************************************/
            ///***                                        ***/
            ///***     DURATION & CONVEXITY FUNCTIONS     ***/
            ///***                                        ***/
            ///**********************************************/

            //Test_financial.test_CFCONVEXITY();
            //Test_financial.test_CFDURATION();
            //Test_financial.test_CFMDURATION();
            //Test_financial.test_CONVEXITY();
            //Test_financial.test_DURATION();
            //Test_financial.test_MDURATION();
            //Test_financial.test_OFCCONVEXITY();
            //Test_financial.test_OFCDURATION();
            //Test_financial.test_OFCMDURATION();
            //Test_financial.test_OFLCONVEXITY();
            //Test_financial.test_OFLDURATION();
            //Test_financial.test_OFLMDURATION();
            //Test_financial.test_OLCCONVEXITY();
            //Test_financial.test_OLCDURATION();
            //Test_financial.test_OLCMDURATION();
            //Test_financial.test_RPICONVEXITY();
            //Test_financial.test_RPIDURATION();
            //Test_financial.test_RPIMDURATION();
            //Test_financial.test_STEPCONVEXITY();
            //Test_financial.test_STEPDURATION();
            //Test_financial.test_STEPMDURATION();

            ///******************************************/
            ///***                                    ***/
            ///***     ACCRUED INTEREST FUNCTIONS     ***/
            ///***                                    ***/
            ///******************************************/

            //Test_financial.test_ACCINTACT();
            //Test_financial.test_ACCRINT();
            //Test_financial.test_ACCRINTM();
            //Test_financial.test_AIFACTOR();
            //Test_financial.test_AIFACTOR_IAM();
            //Test_financial.test_AIFACTOR_OFC();
            //Test_financial.test_AIFACTOR_OLC();
            //Test_financial.test_AIFACTOR_RPI();
            //Test_financial.test_AMORTRATE();
            //Test_financial.test_BONDAMORT();
            //Test_financial.test_BONDINT();
            //Test_financial.test_COMPINT();
            //Test_financial.test_ODDCOMPINT();
            //Test_financial.test_ODDFINT();
            //Test_financial.test_ODDLINT();
            //Test_financial.test_STEPACCINT();

            //**************************************
            //***                                ***
            //***     SPREAD PRICING FUNCTIONS   ***
            //***                                ***
            //**************************************

            //Test_financial.test_BondPriceFromZeroes()
            //Test_financial.test_CMTCurve()
            //Test_financial.test_LogNormalIRLattice()
            //Test_financial.test_OAC()
            //Test_financial.test_OAD()
            //Test_financial.test_OAS()
            //Test_financial.test_PriceFromIRLattice()
            //Test_financial.test_PriceFromZeroesTVF()
            //Test_financial.test_ZSPREAD()

            ///*********************************/
            ///***                           ***/
            ///***     ANNUITY FUNCTIONS     ***/
            ///***                           ***/
            ///*********************************/

            //Test_financial.test_PV();
            //Test_financial.test_PMT();
            //Test_financial.test_RATE();
            //Test_financial.test_NPER();
            //Test_financial.test_IPMT();
            //Test_financial.test_PPMT();
            //Test_financial.test_CUMIPMT();
            //Test_financial.test_CUMPRINC();
            //Test_financial.test_FV();
            //Test_financial.test_PMTSCHED();
            //Test_financial.test_ODDFPMT();
            //Test_financial.test_ODDFPV();
            //Test_financial.test_ODDFRATE();
            //Test_financial.test_ODDFIPMT();
            //Test_financial.test_ODDFPPMT();
            //Test_financial.test_CUMODDFIPMT();
            //Test_financial.test_CUMODDFPPMT();
            //Test_financial.test_ODDFPMTSCHED();
            //Test_financial.test_PVGA();
            //Test_financial.test_PMTGA();
            //Test_financial.test_FVGA();
            //Test_financial.test_NPERGA();

            ///*************************************************/
            ///***                                           ***/
            ///***     INTERNAL RATE OF RETURN FUNCTIONS     ***/
            ///***                                           ***/
            ///*************************************************/

            //Test_financial.test_AMORTIZECASHFLOWS();
            //Test_financial.test_IRR();
            //Test_financial.test_MIRR();
            //Test_financial.test_XIRR();
            //Test_financial.test_XIRR30360();
            //Test_financial.test_XIRRT();
            //Test_financial.test_XMIRR();

            ///*******************************************/
            ///***                                     ***/
            ///***     NET PRESENT VALUE FUNCTIONS     ***/
            ///***                                     ***/
            ///*******************************************/

            //Test_financial.test_EFV();
            //Test_financial.test_ENPV();
            //Test_financial.test_EPV();
            //Test_financial.test_NFV();
            //Test_financial.test_NPV();
            //Test_financial.test_XDCF();
            //Test_financial.test_XFV();
            //Test_financial.test_XNFV();
            //Test_financial.test_XNPV();
            //Test_financial.test_XNPV30360();
            //Test_financial.test_XNPVT();
            //Test_financial.test_XPV();

            ///******************************************************/
            ///***                                                ***/
            ///***     TIME-WEIGHTED RATE OF RETURN FUNCTIONS     ***/
            ///***                                                ***/
            ///******************************************************/

            //Test_financial.test_EMDIETZ();
            //Test_financial.test_GTWRR();
            //Test_financial.test_MDIETZ();
            //Test_financial.test_LMDIETZ();
            //Test_financial.test_TWROR();
            //Test_financial.test_TWRR();

            ///*****************************************************/
            ///***                                               ***/
            ///***     CAPITAL ASSET PRICING MODEL FUNCTIONS     ***/
            ///***                                               ***/
            ///*****************************************************/

            //Test_financial.test_BetaCoKurt();
            //Test_financial.test_BetaCoSkew();
            //Test_financial.test_BetaCoVar();
            //Test_financial.test_DownsideDeviation();
            //Test_financial.test_DownsideFrequency();
            //Test_financial.test_DownsidePotential();
            //Test_financial.test_EQALPHA();
            //Test_financial.test_EQBETA();
            //Test_financial.test_EQVOLATILITY();
            //Test_financial.test_FinCoKurt();
            //Test_financial.test_FinCoSkew();
            //Test_financial.test_INFORATIO();
            //Test_financial.test_INFORATIO2();
            //Test_financial.test_MAXDD();
            //Test_financial.test_MAXDD2();
            //Test_financial.test_MOIC();
            //Test_financial.test_Omega();
            //Test_financial.test_OmegaExcessReturns();
            //Test_financial.test_OmegaSharpeRatio();
            //Test_financial.test_SemiDeviation();
            //Test_financial.test_SemiVariance();
            //Test_financial.test_SHARPE();
            //Test_financial.test_SHARPE2();
            //Test_financial.test_SORTINO();
            //Test_financial.test_SORTINO2();
            //Test_financial.test_SpecificRisk();
            //Test_financial.test_SystematicRisk();
            //Test_financial.test_TotalRisk();
            //Test_financial.test_TREYNOR();
            //Test_financial.test_TREYNOR2();
            //Test_financial.test_UpsideFrequency();
            //Test_financial.test_UpsidePotentialRatio();
            //Test_financial.test_UpsideRisk();

            ///******************************/
            ///***                        ***/
            ///***     LOAN FUNCTIONS     ***/
            ///***                        ***/
            ///******************************/

            //Test_financial.test_CUMLIPMT();
            //Test_financial.test_CUMLPPMT();
            //Test_financial.test_EFFECT();
            //Test_financial.test_FVSCHEDULE();
            //Test_financial.test_LIPMT();
            //Test_financial.test_LPMT();
            //Test_financial.test_LPMTSCHED();
            //Test_financial.test_LPPMT();
            //Test_financial.test_LRATE();
            //Test_financial.test_NOMINAL();
            //Test_financial.test_NUMPMTS();
            //Test_financial.test_ODDPV();
            //Test_financial.test_TOTALINT();

            ///*******************************************/
            ///***                                     ***/
            ///***     LOAN AMORTIZATION FUNCTIONS     ***/
            ///***                                     ***/
            ///*******************************************/

            //Test_financial.test_AMORTSCHED();
            //Test_financial.test_Balloon();
            //Test_financial.test_Bullet();
            //Test_financial.test_CDRCashFlow();
            //Test_financial.test_ConstantCashFlow();
            //Test_financial.test_ConstantCashFlowFR();
            //Test_financial.test_ConstantPaymentAmount();
            //Test_financial.test_ConstantPrincipal();
            //Test_financial.test_ConstantPrincipalAmount();
            //Test_financial.test_ConstantPrincipalRate();
            //Test_financial.test_CONSTPRINAMORT();
            //Test_financial.test_NPD();
            //Test_financial.test_NPNO();
            //Test_financial.test_PAYMENTPERIODS();
            //Test_financial.test_PERIODRATE();
            //Test_financial.test_PPD();
            //Test_financial.test_PPNO();
            ////Test_financial.test_SMMAmort();
            //Test_financial.test_UNEQUALLOANPAYMENTS();

            ///************************************/
            ///***                              ***/
            ///***     Rule-of-78 FUNCTIONS     ***/
            ///***                              ***/
            ///************************************/

            //Test_financial.test_R78IPMT();
            //Test_financial.test_R78PAYOFF();
            //Test_financial.test_R78PPMT();
            //Test_financial.test_R78REBATE();

            ///*************************************/
            ///***                               ***/
            ///***    DEPRECIATION FUNCTIONS     ***/
            ///***                               ***/
            ///*************************************/

            //Test_financial.test_DB();
            //Test_financial.test_DDB();
            //Test_financial.test_SLN();
            //Test_financial.test_SYD();
            //Test_financial.test_VDB();

            ///*************************************************/
            ///***                                           ***/
            ///***    YIELD CURVE CONSTRUCTION FUNCTIONS     ***/
            ///***                                           ***/
            ///*************************************************/

            //Test_financial.test_DFINTERP();
            //Test_financial.test_ED_FUT_CONV_ADJ_HL();
            //Test_financial.test_INTERPDFACT();
            //Test_financial.test_SWAPCURVE();
            //Test_financial.test_ZEROCOUPON();

            ///**************************************/
            ///***                                ***/
            ///***    NELSON/SIEGEL FUNCTIONS     ***/
            ///***                                ***/
            ///**************************************/

            //Test_financial.test_NELSONSIEGEL();
            //Test_financial.test_NSCOEF();
            //Test_financial.test_NSCOEF2();

            ///*****************************************************/
            ///***                                               ***/
            ///***    YIELD CURVE DATE CALCULATION FUNCTIONS     ***/
            ///***                                               ***/
            ///*****************************************************/

            //Test_financial.test_ED_FUTYF();
            //Test_financial.test_ED_FUT2DATE();
            //Test_financial.test_TENOR2DATE();

            ///**************************************************/
            ///***                                            ***/
            ///***    BUSINESS DAYS CALCULATION FUNCTIONS     ***/
            ///***                                            ***/
            ///**************************************************/

            //Test_financial.test_BUSDAYS();
            //Test_financial.test_BUSDAYSWE();
            //Test_financial.test_BUSINESSDATE();
            //Test_financial.test_BUSINESSDATEWE();
            //Test_financial.test_T360();

            ///**************************************/
            ///***                                ***/
            ///***    BUSINESS DATE FUNCTIONS     ***/
            ///***                                ***/
            ///**************************************/

            //Test_financial.test_CALCDATE();
            //Test_financial.test_DATEFLOAT();
            //Test_financial.test_DATEINT();
            //Test_financial.test_DAYS360();
            //Test_financial.test_DAYSINMONTH();
            //Test_financial.test_DAYSINYEAR();
            //Test_financial.test_DAYSNL();
            //Test_financial.test_EASTER();
            //Test_financial.test_EDATE();
            //Test_financial.test_EOMONTH();
            //Test_financial.test_FIRSTWEEKDAY();
            //Test_financial.test_ISREGULARPAY();
            //Test_financial.test_LASTWEEKDAY();
            //Test_financial.test_NBD();
            //Test_financial.test_NUMMONTHS();
            //Test_financial.test_YEARFRAC();

            ///**************************************/
            ///***                                ***/
            ///***    MISCELLANEOUS FUNCTIONS     ***/
            ///***                                ***/
            ///**************************************/

            //Test_financial.test_DOLLARDE();
            //Test_financial.test_DOLLARFR();

            //Test_financial.test_XLDLL_FINANCIAL_VERSION();


            //------------------------------------------------

            Console.WriteLine("\r\n\r\n-----------------\r\n");
            Console.WriteLine("Done!");
            MessageBox.Show("Done!");
        }

    }

    //--------------------------------------------------

    public class TextBoxStreamWriter : TextWriter
    {
        private TextBox _output;

        public TextBoxStreamWriter(TextBox Output)
        {
            _output = Output;
        }

        public override System.Text.Encoding Encoding
        {
            get
            {
                return System.Text.Encoding.UTF8;
            }
        }

        public override void WriteLine(String value)
        {
            base.WriteLine(value);
            _output.SuspendLayout();
            _output.AppendText(value);
            _output.ResumeLayout();
        }

    }

}

